﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;

namespace MyMemcached
{
    public partial class DataTraversal : Form
    {
        DAO.Stats stats = MainForm.Stats;
        Dictionary<string, object> statSlabs = MainForm.StatSlabs;
        Dictionary<string, object> statsItems = MainForm.StatsItems;
        private string Slab { get; set; }
        private string Count { get; set; }

        public DataTraversal()
        {
            InitializeComponent();
            DataBind();
        }

        private void DataBind()
        {
            foreach (string slab in statSlabs.Keys)
            {
                if (slab.Equals("active_slabs") || slab.Equals("total_malloced"))
                {
                    continue;
                }
                cmbSlabs.Items.Add(slab);
            }
            cmbSlabs.SelectedIndex = 0;

            string count = statsItems.ContainsKey(cmbSlabs.SelectedItem.ToString()) ?
                 ((Dictionary<string, string>)statsItems[cmbSlabs.SelectedItem.ToString()])["number"]
                 : "0";
            lbItemsCount.Text = "区块内共有记录: " + count;
        }

        private void cmbSlabs_SelectedIndexChanged(object sender, EventArgs e)
        {
            string count = statsItems.ContainsKey(cmbSlabs.SelectedItem.ToString()) ?
                 ((Dictionary<string, string>)statsItems[cmbSlabs.SelectedItem.ToString()])["number"]
                 : "0";
            lbItemsCount.Text = "区块内共有记录: " + count;
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            Slab = cmbSlabs.SelectedItem.ToString();

            int count;
            if (!int.TryParse(tbCount.Text, out count))
            {
                MessageBox.Show("查找数目输入错误");
                return;
            }
            Count = count.ToString();
            richTextBox1.ResetText();
            progressBar1.Maximum = count;
            btnGo.Enabled = false;

            Thread thread = new Thread(new ThreadStart(Loop));
            thread.IsBackground = true;
            thread.Start();
        }


        private void Loop()
        {
            int i = 1;
            foreach (var cachedump in stats.CacheDump(Servers.CurrentServer, Slab, Count))
            {
                var getResult = stats.Get(Servers.CurrentServer, cachedump.Key);
                SetTextBox(string.Format("Key\t{0} {1}{2}", cachedump.Key, cachedump.Value,Environment.NewLine));
                if (getResult.ContainsKey("type"))
                {
                    SetTextBox(string.Format("Type\t{0}{1}", getResult["type"], Environment.NewLine));
                }
                SetTextBox(string.Format("Value{1}{0}{1}{1}", getResult["value"], Environment.NewLine));
                SetPbValue(i);
                i++;
            }
            SetPbValue(0);
            this.BeginInvoke(new MethodInvoker(delegate()
            {
                btnGo.Enabled = true;
            }));
        }

        #region richTextBox1 代理
        delegate void TextBoxDel(string str);

        private void SetTextBox(string str)
        {
            if (richTextBox1.InvokeRequired)
            {
                Invoke(new TextBoxDel(SetTextBox), new string[] { str });
            }
            else
            {
                richTextBox1.AppendText(str);
            }
        }
        #endregion

        #region 进度条代理
        delegate void pbDelegate(int value);

        private void SetPbValue(int value)
        {
            if (progressBar1.InvokeRequired)
            {
                Invoke(new pbDelegate(SetPbValue), new object[] { value });
            }
            else
            {
                progressBar1.Value = value;
            }
        }
        #endregion
    }
}
