﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MyMemcached
{
    public partial class TelnetCmd : Form
    {
        Stack<string> up = new Stack<string>();
        Stack<string> down = new Stack<string>();
        public TelnetCmd()
        {
            InitializeComponent();
            ServerListBind();
        }

        private void btnGo_Click(object sender, EventArgs e)
        {
            cmdResult.AppendText(string.Format("-------{0}:{1}-------", ServerList.SelectedItem.ToString(), cmdText.Text));

            string usefulcmd = usefulCmd.SelectedItem != null ? usefulCmd.SelectedItem.ToString() : string.Empty;
            if (usefulcmd.EndsWith("<value>"))
            {
                try
                {
                    string[] cmd = cmdText.Text.Split();
                    if (cmd[0] == "set")
                    {
                        string realcmd = string.Format("set {0} 0 30 {1}", cmd[1], cmd[2].Length);
                        Run(realcmd);
                        realcmd = cmd[2];
                        Run(realcmd);
                    }
                    else if (cmd[0] == "cas")
                    {
                        string realcmd = string.Format("cas {0} 0 0 {1} {2}", cmd[1], cmd[3].Length, cmd[2]);
                        Run(realcmd);
                        realcmd = cmd[3];
                        Run(realcmd);
                    }
                    else
                    {
                        Run(cmdText.Text);
                    }
                }
                catch
                {
                    MessageBox.Show("命令格式错误");
                }
            }
            else
            {
                Run(cmdText.Text);
            }

            int count = down.Count;
            for (int i = 0; i < count; i++)
            {
                up.Push(down.Pop());
            }
            up.Push(cmdText.Text);
            cmdText.Text = string.Empty;
            cmdText.Focus();
        }

        private void Run(string cmd)
        {
            TelnetConnection telnet = Servers.ServerList[ServerList.SelectedItem.ToString()];
            telnet.WriteLine(cmd);
            cmdResult.AppendText(string.Format("\r\n{0}\r\n", telnet.Read()));
            cmdResult.ScrollToCaret();
        }

        private void cmdText_KeyDown(object sender, KeyEventArgs e)
        {
            switch (e.KeyValue)
            {
                //回车
                case 13:
                    btnGo_Click(sender, e);
                    break;
                //up
                case 38:
                    StackWork(up, down);
                    break;
                //down
                case 40:
                    StackWork(down, up);
                    break;
            }
        }

        /// <summary>
        /// 上下按键取回textbox的输入记录
        /// </summary>
        /// <param name="beofre"></param>
        /// <param name="after"></param>
        private void StackWork(Stack<string> beofre, Stack<string> after)
        {
            string val;
            if (beofre.Count <= 0)
                return;
            val = beofre.Pop();
            cmdText.Text = val;
            if (after.Count > 0)
            {
                if (!after.Peek().Equals(val))
                { after.Push(val); }
            }
            else
            {
                after.Push(val);
            }
        }

        //绑定combobox的数据
        private void ServerListBind()
        {
            if (Servers.ServerList.Keys.Count == 0) return;

            foreach (var server in Servers.ServerList.Keys)
            {
                ServerList.Items.Insert(0, server);
            }
            ServerList.SelectedIndex = 0;
        }

        private void usefulCmd_SelectedIndexChanged(object sender, EventArgs e)
        {
            string cmd = usefulCmd.SelectedItem.ToString().Split(new char[] { '<' })[0];
            cmdText.Text = cmd;
            cmdText.Focus();
            cmdText.SelectionStart = cmd.Length;
        }
    }
}
